# Changelog

All notable changes to this project will be documented in this file.

## [0.27.0-alpha.1+9] - 2024-08-12

### 🚀 Features

- *(core)* Изменено поведение обхода схемы schema.Walk, считаем что объект изменился при установке значения Nil ([#PRXS-2648](https://tracker.yandex.ru/PRXS-2648))-([8a7f62f](https://git.perx.ru/perxis/perxis-go/-/commit/8a7f62fcd93f114e941538fe09f41b9c0927ceb0))
- *(schema)* Реализован функционал для загрузки схем из файлов ([#PRXS-2731](https://tracker.yandex.ru/PRXS-2731))-([0255aad](https://git.perx.ru/perxis/perxis-go/-/commit/0255aad01984ac7b39385df1132f6ed3289e2ba4))
- *(core)* Добавлен вызов Visitors при компиляции expr-выражения в bson. Добавлен метод Schema.SetSingleLocale ([#PRXS-2656](https://tracker.yandex.ru/PRXS-2656))-([60c45b0](https://git.perx.ru/perxis/perxis-go/-/commit/60c45b0cb14ae81835859ce9e5303a7fba5b733b))

### 🐛 Bug Fixes

- *(core)* Исправлена ошибка "assignment to entry in nil map" если у объекта схемы отсутствовали поля ([#PRXS-2770](https://tracker.yandex.ru/PRXS-2770))-([3c4b955](https://git.perx.ru/perxis/perxis-go/-/commit/3c4b955915e26b063aceac7169d6b0f82b7c96bf))
- *(core)* Исправлена ошибка "panic: runtime error: invalid memory address or nil pointer dereference" при вызове UnmarshalJSON при передаче "null" ([#PRXS-2770](https://tracker.yandex.ru/PRXS-2770))-([36e8b6a](https://git.perx.ru/perxis/perxis-go/-/commit/36e8b6a965cd0b0a7977340c8eea5c9672f168a3))

## [0.27.0] - 2024-07-24

### 🚀 Features

- Добавлен пакет `localizer` для  работы с переводами данных ([#PRXS-2653](https://tracker.yandex.ru/PRXS-2653))-([53a37c4](https://git.perx.ru/perxis/perxis-go/-/commit/53a37c45a8a76e2b4cf7f2b5a7874b06465269b9))
- *(core)* Внесены изменения для работы с переводами через Items API -([ebf80bb](https://git.perx.ru/perxis/perxis-go/-/commit/ebf80bb317f126f85e69a813651054fbf77a2bae))
- *(logs)* Обновление API логирования, релевантность результатов поиска ([#PRXS-2665](https://tracker.yandex.ru/PRXS-2665))-([97077fb](https://git.perx.ru/perxis/perxis-go/-/commit/97077fbc800a3c3d865ee35a485ed8b6396f3444))
- *(core)* Обновление References API: поддержка локализации контента -([87b92c5](https://git.perx.ru/perxis/perxis-go/-/commit/87b92c5bc30d1c26b280c85b447a0ca9d313df34))
- *(core)* Реализована возможность загрузки схем из YAML и JSON файлов ([#PRXS-2731](https://tracker.yandex.ru/PRXS-2731))-([bf29420](https://git.perx.ru/perxis/perxis-go/-/commit/bf294207182bbc0b5ce154029f98aaca00b9c831))

### 🐛 Bug Fixes

- *(core)* Исправлен обход схемы Walk для типа Array, решена ошибка отсутствия схемы при вызове Introspect -([2f684ea](https://git.perx.ru/perxis/perxis-go/-/commit/2f684ea678c0bcd59b8faed69cace00c9a4d29e6))
- *(core)* Исправлена ошибка при которой не логировались действия с пространствами ([#PRXS-2609](https://tracker.yandex.ru/PRXS-2609))-([d0a7606](https://git.perx.ru/perxis/perxis-go/-/commit/d0a7606248f7e7a3a21075592d69d6845b546cce))
- *(core)* Исправлена ошибка при которой была возможность изменить обьект находящийся в кеше Items ([#PRXS-2697](https://tracker.yandex.ru/PRXS-2697))-([cd5724d](https://git.perx.ru/perxis/perxis-go/-/commit/cd5724d316f2a0a6738a6159bdfb974938e8fde2))

### ⚙️ Miscellaneous Tasks

- *(api)* Исправлены ошибки linter`а связанные с пропущенными именами переменных при получении результатов ([#PRXS-2610](https://tracker.yandex.ru/PRXS-2610))-([90269af](https://git.perx.ru/perxis/perxis-go/-/commit/90269aff2bae12a05d5394eb223e08ff6c2bdb2f))
- *(core)* Исправлена передача объектов в кэше сервисов ([#PRXS-2705](https://tracker.yandex.ru/PRXS-2705))-([9180ee7](https://git.perx.ru/perxis/perxis-go/-/commit/9180ee7aa4c433e02030659489adca91bc4c8401))

## [0.25.1] - 2024-06-13

### 🐛 Bug Fixes

- *(core)* Исправлен deadlock при одновременном вызове BufferedWriteSyncer.Stop и синхронизации по интервалу ([#PRXS-2576](https://tracker.yandex.ru/PRXS-2576))-([3b823ed](https://git.perx.ru/perxis/perxis-go/-/commit/3b823ed00a22e142e25137dccb5f1c4fbb318d3f))

## [0.25.0] - 2024-05-08

### 🚀 Features

- *(core)* Добавлена возможность использовать символ "-" в названиях полей ([#PRXS-1439](https://tracker.yandex.ru/PRXS-1439))-([66b02b9](https://git.perx.ru/perxis/perxis-go/-/commit/66b02b9a6defdbe5e5d5502ff45d67c38c2a5fa4))
- *(api)* Добавлен метод внутренний метод установки состояния пространства SetState для сервиса Spaces ([#PRXS-2223](https://tracker.yandex.ru/PRXS-2223))-([0057019](https://git.perx.ru/perxis/perxis-go/-/commit/005701931ea9c03d8e54ffa6bbcf351254ff578e))
- Добавлен метод Find для сервиса Spaces ([#PRXS-2298](https://tracker.yandex.ru/PRXS-2298))-([4135690](https://git.perx.ru/perxis/perxis-go/-/commit/41356904837085adc48f4c8c6edaf8ad7d7fd014))
- *(core)* Добавлено системное поле SearchScore в Item ([#PRXS-2445](https://tracker.yandex.ru/PRXS-2445))-([087edb3](https://git.perx.ru/perxis/perxis-go/-/commit/087edb39bbe6d22e12dedd9d4795336556f7b844))

### ⚙️ Miscellaneous Tasks

- Перенесено содержимое пакета pkg/id на уровень выше в пакет id -([d13399f](https://git.perx.ru/perxis/perxis-go/-/commit/d13399fd6c26349f7ddf36c4d4e81568a2503a9c))
- *(core)* Возврат GRPC-ошибки в сервисах -([c6bf265](https://git.perx.ru/perxis/perxis-go/-/commit/c6bf265699d5e9a99c0f583d7b6782b53cda3674))

## [0.24.0] - 2024-04-12

### 🚀 Features

- Добавлен OID для Locales -([221d730](https://git.perx.ru/perxis/perxis-go/-/commit/221d730e552dd64d0dc32b21e799a75c6adf4503))
- Добавлены методы Space, Environment, Collection, Organization для объекта System, который используется в шаблонах ([#PRXS-1813](https://tracker.yandex.ru/PRXS-1813))-([d017315](https://git.perx.ru/perxis/perxis-go/-/commit/d017315e664a9c5fcd84e377e5ba4f3635308f0b))

### 🐛 Bug Fixes

- *(core)* Изменено название и значение констант событий в logging_middleware для коллекций ([#PRXS-2199](https://tracker.yandex.ru/PRXS-2199))-([0cb42c5](https://git.perx.ru/perxis/perxis-go/-/commit/0cb42c57c0b976e9f9dd2f21e326f17d84580969))

## [0.22.0] - 2024-03-06

### 🚀 Features

- В пакет data добавлена проверка при установке значения на то, инициализирована ли map -([978a2c9](https://git.perx.ru/perxis/perxis-go/-/commit/978a2c9dc0c6c554ed35f046e33321e2c250fcf2))
- *(core)* Добавлены функции exists и len для языка запросов expr ([#PRXS-1883](https://tracker.yandex.ru/PRXS-1883))-([eae58bf](https://git.perx.ru/perxis/perxis-go/-/commit/eae58bf4c3cad9fe793b8ccf763bf9ada46266a3))
- *(extensions)* Добавлена по умолчанию для отображения Icon первой колонкой для коллекции "Настройки/Действия" ([#PRXS-1950](https://tracker.yandex.ru/PRXS-1950))-([9a3936b](https://git.perx.ru/perxis/perxis-go/-/commit/9a3936bea15bd80201b1ae9ffe1518b424dcb1d1))
- Add filter_core.go -([37d3135](https://git.perx.ru/perxis/perxis-go/-/commit/37d313519b69d83d97560a5c09722cec959596a9))
- Add unused v2 entry encoder -([79d8eef](https://git.perx.ru/perxis/perxis-go/-/commit/79d8eefc88b4b7c26b855df1492506131184f1a9))

### 🐛 Bug Fixes

- Исправлена потенциальная утечка ресурсов в HTTP-загрузчике файлов (используется в сервисе Images) ([#PRXS-1977](https://tracker.yandex.ru/PRXS-1977))-([143766b](https://git.perx.ru/perxis/perxis-go/-/commit/143766b56f638a43281c26e9d79842198750db6b))
- *(sync)* Исправлена ошибка синхронизации "received message larger than max". Процесс синхронизации значительно ускорен ([#PRXS-2026](https://tracker.yandex.ru/PRXS-2026))-([083aaf1](https://git.perx.ru/perxis/perxis-go/-/commit/083aaf1f363093219bb58f67b1accbc5a31f097a))
- Add id import -([6c0ecb0](https://git.perx.ru/perxis/perxis-go/-/commit/6c0ecb0ee0786ae6f388e486c6210e79354f4f88))

### ⚙️ Miscellaneous Tasks

- Обновлена библиотека github.com/expr-lang/expr до версии v1.15.8 ([#PRXS-1667](https://tracker.yandex.ru/PRXS-1667))-([d0069ab](https://git.perx.ru/perxis/perxis-go/-/commit/d0069ab4893e7c0acf360b5a42759d74c6a5cb32))

## [0.21.0] - 2024-01-16

### 🚀 Features

- Добавлен интерфейс Cache ([#PRXS-1859](https://tracker.yandex.ru/PRXS-1859))-([c11dae6](https://git.perx.ru/perxis/perxis-go/-/commit/c11dae6a20e9ff04d3840ba4de87998d9eb72e6e))
- Внесены правки в Spaces после изменений в perxis-proto, перегенерированны grpc-клиенты для Spaces ([#PRXS-1835](https://tracker.yandex.ru/PRXS-1835))-([2a0c015](https://git.perx.ru/perxis/perxis-go/-/commit/2a0c01544486fac5f5cb505a1dab7aa88d7858f4))
- Добавлена метрика для кэша -([3a6a7a3](https://git.perx.ru/perxis/perxis-go/-/commit/3a6a7a300dd7bad9597c4583871813ac5edecd52))
- Функция argsToLabels была вынесена в пакет metrics и переименована в GetLabelsFromKV. Теперь функция игнорирует значение без ключа -([b0b4312](https://git.perx.ru/perxis/perxis-go/-/commit/b0b4312d8399b3933af35b88bad301a89488f353))
- Добавлены metrics middleware для остальных сервисов -([8808371](https://git.perx.ru/perxis/perxis-go/-/commit/8808371cc465b0c16e6c41bd1ab5bf89a466a0ef))
- *(core)* Добавлена сборка метрик кэша и запросов ([#PRXS-1219](https://tracker.yandex.ru/PRXS-1219))-([706b266](https://git.perx.ru/perxis/perxis-go/-/commit/706b2666190347d594c13d5d3f0f13586463be2a))
- *(extension)* Добавлен middleware для сбора телеметрии -([221a13f](https://git.perx.ru/perxis/perxis-go/-/commit/221a13f8d19df03106afda566cad011178b1489a))
- *(core)* Добавлен сбор телеметрии в менеджере расширений ([#PRXS-1898](https://tracker.yandex.ru/PRXS-1898))-([1f18b52](https://git.perx.ru/perxis/perxis-go/-/commit/1f18b5226a8473a5b509ce0cf7001f2e1525b395))

### 🐛 Bug Fixes

- *(items)* Исправлены тесты -([57e7765](https://git.perx.ru/perxis/perxis-go/-/commit/57e776563ae3f6b14338f7fbb2d073ad40496d51))
- *(items)* Добавлена метрика в CachingMiddleware -([68796ee](https://git.perx.ru/perxis/perxis-go/-/commit/68796ee090f68e16092a88e480900807e229ba80))
- *(delivery)* Добавлена метрика в CachingMiddleware -([3f182d1](https://git.perx.ru/perxis/perxis-go/-/commit/3f182d11c13c914f6b7b8556f4082ce03ce937cb))

### 📚 Documentation

- Добавлен комментарий -([c715ad8](https://git.perx.ru/perxis/perxis-go/-/commit/c715ad8d8123ca244f8eaa92f7456c9e99101fb4))
- Добавлены подсказки к метрикам -([2387dac](https://git.perx.ru/perxis/perxis-go/-/commit/2387dac81918f252ac293a0f385d6e9149ec5924))

## [0.20.0] - 2023-12-01

### 🐛 Bug Fixes

- *(extensions)* Исправлена ошибка, при которой при обновлении расширений для некоторых коллекций всегда переустанавливались схемы, в которых не было изменений. Добавлен возврат ошибки при любом действии с расширением в случае неправильной его конфигурации ([#PRXS-1695](https://tracker.yandex.ru/PRXS-1695))-([998f3e8](https://git.perx.ru/perxis/perxis-go/-/commit/998f3e84ba73b241740a404d097d2b7c65cd352a))
- *(core)* Исправлена ошибка, при которой запрещенные правилами поля во вложенных объектах все равно были доступны пользователю ([#PRXS-1673](https://tracker.yandex.ru/PRXS-1673))-([0e1bec9](https://git.perx.ru/perxis/perxis-go/-/commit/0e1bec99fa78ad6f55e74e4cf6c38ee90cc5f205))

## [0.19.0] - 2023-11-03

### 🚀 Features

- *(core)* Добавлено поле метадата в схему коллекций, для хранения дополнительной информации о коллекции -([05a7965](https://git.perx.ru/perxis/perxis-go/-/commit/05a7965aa95768f1053854947cf4f4365ce81fd7))
- *(extensions)* Переработана процедура установки коллекций (Установка расширений) учитывающая что коллекция могла быть создана пользователем и предотвращающая перезапись и потерю данных ([#PRXS-1380](https://tracker.yandex.ru/PRXS-1380))-([1f00274](https://git.perx.ru/perxis/perxis-go/-/commit/1f00274400637dd64d83176f1b650c8b7c129f72))
- *(extension)* При установке расширения схемы коллекций принадлежащих расширению по-умолчанию будут обновлены.  ([#PRXS-1380](https://tracker.yandex.ru/PRXS-1380))-([0dc7312](https://git.perx.ru/perxis/perxis-go/-/commit/0dc7312912999b811d5e48f247afbed3d737c9d7))
- *(extensions)* При установке расширения больше не перезаписывают конфликтные схемы коллекций. (Удален временный флаг _alwaysSetSchema в Setup) ([#PRXS-1472](https://tracker.yandex.ru/PRXS-1472))-([278b2cb](https://git.perx.ru/perxis/perxis-go/-/commit/278b2cbc96e4ebfbf34e21dccffb929754f9a829))

### 🐛 Bug Fixes

- *(core)* Пакеты 'service' в которых лежат middlewares переименованы на 'middleware' ([#PRXS-1163](https://tracker.yandex.ru/PRXS-1163))-([75f3153](https://git.perx.ru/perxis/perxis-go/-/commit/75f31532aa7b3007d9ff32c89ec6b62877b93085))
- *(core)* Исправлена ошибка, из-за которой проверка на принадлежность пользователя к разным организациям отрабатывала некорректно. Добавлена очистка кэша при переносе пространства ([#PRXS-1297](https://tracker.yandex.ru/PRXS-1297))-([7aa1d49](https://git.perx.ru/perxis/perxis-go/-/commit/7aa1d497cbd84e4e7b08508d645d794ef77a27ac))
- *(sdk)* Исправлена ошибка 'failed to uninstall client: not found', возникающая при удалении расширения, клиент которого уже не существует ([#PRXS-1342](https://tracker.yandex.ru/PRXS-1342))-([a170724](https://git.perx.ru/perxis/perxis-go/-/commit/a1707249ff2b82589a990cf08352debb58d467df))
- *(core)* Исправлена выгрузка лишних полей ("published_at", "published_by", "archived_at","archived_by")  в файл при экспорте данных ([#PRXS-1390](https://tracker.yandex.ru/PRXS-1390))-([6dc87f8](https://git.perx.ru/perxis/perxis-go/-/commit/6dc87f8bf1acf2e12a7dc9858ab6407b9ac9ee78))

<!-- generated by git-cliff -->
