package grpc

import (
	"git.perx.ru/perxis/perxis-go/pkg/errors"
	"git.perx.ru/perxis/perxis-go/proto/common"
	"google.golang.org/grpc/status"
)

func StatusFromError(err error) *status.Status {
	if err == nil {
		return nil
	}
	pberr := ProtoFromError(err)
	st := status.New(errors.GetStatusCode(err), err.Error())
	st, _ = st.WithDetails(pberr)
	return st
}

func ErrorFromStatus(st *status.Status) error {
	details := st.Details()
	err := errors.New(st.Message())
	if len(details) > 0 {
		if pberr, ok := details[0].(*common.Error); ok {
			err = ErrorFromProto(err, pberr)
		}
	}
	err = errors.WithStatusCode(err, st.Code())
	return err
}
