// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/invitations -i Invitations -t ../../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/invitations"
	"git.perx.ru/perxis/perxis-go/pkg/options"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements invitations.Invitations that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   invitations.Invitations
}

// AccessLoggingMiddleware instruments an implementation of the invitations.Invitations with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next invitations.Invitations) invitations.Invitations {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) Accept(ctx context.Context, invitationId string, userId string) (err error) {
	begin := time.Now()

	m.logger.Debug("Accept.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("invitationId", invitationId),
		zap.Reflect("userId", userId),
	)

	err = m.next.Accept(ctx, invitationId, userId)

	m.logger.Debug("Accept.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Create(ctx context.Context, invitation *invitations.Invitation) (created *invitations.Invitation, err error) {
	begin := time.Now()

	m.logger.Debug("Create.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("invitation", invitation),
	)

	created, err = m.next.Create(ctx, invitation)

	m.logger.Debug("Create.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("created", created),
		zap.Error(err),
	)

	return created, err
}

func (m *accessLoggingMiddleware) Delete(ctx context.Context, invitationId string) (err error) {
	begin := time.Now()

	m.logger.Debug("Delete.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("invitationId", invitationId),
	)

	err = m.next.Delete(ctx, invitationId)

	m.logger.Debug("Delete.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Find(ctx context.Context, filter *invitations.Filter, opts *options.FindOptions) (invitations []*invitations.Invitation, total int, err error) {
	begin := time.Now()

	m.logger.Debug("Find.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("filter", filter),
		zap.Reflect("opts", opts),
	)

	invitations, total, err = m.next.Find(ctx, filter, opts)

	m.logger.Debug("Find.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("invitations", invitations),
		zap.Reflect("total", total),
		zap.Error(err),
	)

	return invitations, total, err
}

func (m *accessLoggingMiddleware) Get(ctx context.Context, invitationId string) (invitation *invitations.Invitation, err error) {
	begin := time.Now()

	m.logger.Debug("Get.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("invitationId", invitationId),
	)

	invitation, err = m.next.Get(ctx, invitationId)

	m.logger.Debug("Get.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("invitation", invitation),
		zap.Error(err),
	)

	return invitation, err
}
